// listing2.hpp - Define a thread object.

extern bool bKeepRunning;
void BlockAllSignals();
extern sigset_t SigWaitSet;

class Thread
{
private:
	int iRet;       // Just an all purpose ret value holder
protected:
	pid_t pid;      // Our HWP pid
public:
	bool bVerbose;  // If TRUE, this thread prints out
                        // each iteration.
	thread_t tid;   // Our thread id
	int iCreateError;       // Any thr_create error
	bool Ended;     // TRUE if this thread should terminate itself

	Thread( long flags );   // constructor
	Thread( long flags, void *(*start_routine)(void *arg) );
	bool End();		// Kill the thread
	bool Continue();	// Restart suspended thread
	bool Suspend();		// Suspend execution of a thread
	bool Kill(int sig);		// Suspend execution of a thread
	thread_t GetID() { return tid; };
	void ReportError( int );
};

class BoundThread : public Thread
{
public:
	BoundThread();
	bool isBound() { return( TRUE ); };
	bool isMultiplexed() { return( FALSE ); };
};

class MultiplexedThread : public Thread
{
public:
	MultiplexedThread();
	bool isBound() { return( FALSE ); };
	bool isMultiplexed() { return( TRUE ); };
};

class SignalHandlerThread: public Thread
{
public:
	SignalHandlerThread();
	bool isBound() { return( TRUE ); };
	bool isMultiplexed() { return( FALSE ); };
};

