// Listing 2 -- Thread.cpp

//------------------------- Includes ------------------------------

#define INCL_DOS

#include <windows.h>
#include "Thread.h"

//--------------------------- code --------------------------------

Thread::Thread(PFNTHREADPROC pfnThread, BOOL fStartNow, ULONG ulStack)
{
	ulStackSize = ulStack;
	pfnThreadProc = pfnThread;
	if (fStartNow)
		this->Start();
}

Thread::~Thread() {}	// empty implementation

VOID Thread::Start (ULONG arg, BOOL fSuspended)
{
	DWORD flags = 0;
	DWORD idThread;

	if (fSuspended)
		flags = CREATE_SUSPENDED;
	hThread = CreateThread(NULL, ulStackSize, 
							(LPTHREAD_START_ROUTINE)pfnThreadProc, (LPVOID)arg, 
							flags, &idThread);
}

//------------------------ end of file ----------------------------
