// Listing 1 -- Thread.h

#if !defined(THREADS_INC)
#define THREADS_INC

//---------------------- Constants and Types -----------------------

const int THRDS_DEF_STACK		= 8192;		// default stack size

typedef VOID FNTHREADPROC (VOID * ulArg);	// thread procedure type
typedef FNTHREADPROC* PFNTHREADPROC;

//------------------------------ Class -----------------------------

class Thread {
public:
	Thread(	PFNTHREADPROC pfnThread,				// Constructor
			BOOL fStartNow=FALSE,
			ULONG ulStack=THRDS_DEF_STACK);
		
	virtual ~Thread();								// Destructor

	virtual VOID Start (ULONG arg=0L, BOOL fSuspended=FALSE);

	VOID	Stop(ULONG ulExit=0L)		{	TerminateThread(hThread,ulExit); }

	VOID	Resume()	{	ResumeThread(hThread); }

	VOID	Suspend()	{	SuspendThread(hThread); }

	HANDLE	GetHandle()		{ return hThread; }

private:
	ULONG			ulStackSize;
	HANDLE			hThread;
	PFNTHREADPROC	pfnThreadProc;
};

//-------------------------- End of Header -------------------------
#endif

